
	
var map;
var marker;
var rectangle; 
var utilex=0;
var utiley=0;
var Co1;
var Co2;
var Wpix;
var Hpix;
var Hinch;
var Winch;
var TILE_SIZE = 256;
var image_cont=0;







function lat_to_pix(latLng, zoom) {
	var scale = 1 << zoom;
	var worldCoordinate = project(latLng);
	var pixelCoordinate = new google.maps.Point(
	Math.floor(worldCoordinate.x * scale),
	Math.floor(worldCoordinate.y * scale));

	var tileCoordinate = new google.maps.Point(
	Math.floor(worldCoordinate.x * scale / TILE_SIZE),
	Math.floor(worldCoordinate.y * scale / TILE_SIZE));


	return pixelCoordinate;
}
function project(latLng) {
var siny = Math.sin(latLng.lat() * Math.PI / 180);
siny = Math.min(Math.max(siny, -0.9999), 0.9999);

return new google.maps.Point(
            TILE_SIZE * (0.5 + latLng.lng() / 360),
            TILE_SIZE * (0.5 - Math.log((1 + siny) / (1 - siny)) / (4 * Math.PI)));

}

var Rk = 6371*1000*39.3700787;//inch 
var Torad=Math.PI/180;		
function findDistance(t1,n1,t2,n2) {
		var  lat1, lon1, lat2, lon2, dlat, dlon, a, c, dm, dk, mi, km;
		
		lat1 = t1*Torad;
		lon1 = n1*Torad;
		lat2 = t2*Torad;
		lon2 = n2*Torad;
				
		dlat = lat2 - lat1;
		dlon = lon2 - lon1;
		
		a  = Math.pow(Math.sin(dlat/2),2) + Math.cos(lat1) * Math.cos(lat2) * Math.pow(Math.sin(dlon/2),2);
		c  = 2 * Math.atan2(Math.sqrt(a),Math.sqrt(1-a)); 
		dk = c * Rk; 
		return dk	
}
	

function initMap() {
	

var mapOptions = {
    zoom: 17,
    center: new google.maps.LatLng(sk_lat,sk_lon), 
    mapTypeId: google.maps.MapTypeId.SATELLITE,
 disableDefaultUI: true,
//streetViewControl: false,
	//zoomControl: true,
  //mapTypeControl: true,
  //scaleControl: true
  //streetViewControl: true,
  //rotateControl: true,
  //fullscreenControl: true
  };



  
  
map = new google.maps.Map(document.getElementById('map-canvas'),  mapOptions);
map.setTilt(0);
draw_su_pos();

	
	var el=document.getElementById('grab');
	el.addEventListener("mouseup",  grab_up, false);
	el.addEventListener("mousedown", grab_down, false);
	
	var centerControlDiv = document.createElement('div');
	var controlUI=document.getElementById('arrows_');
	centerControlDiv.appendChild(controlUI);
	centerControlDiv.index = 1;
	map.controls[google.maps.ControlPosition.TOP_CENTER].push(centerControlDiv);
	

	return;
}
function selectregion(){

	var bounds;
	
	if (rectangle){
		rectangle.setMap();
		bounds=center_rectangle();
		}
	else{
		bounds=create_rectangle();
		
	}

rectangle = new google.maps.Rectangle({
    bounds: bounds,
    editable: true,
	draggable: true,
	fillOpacity: 0.3,
	strokeOpacity: 1,
	strokeWeight:1
	//strokeColor: '#99f91b'
	
});
	
	rectangle.setMap(map);
	map.panTo(new google.maps.LatLng(sk_lat,sk_lon));

	return;
}
function create_rectangle(){
	
	var bounds1 = map.getBounds();
	var incr1 = fix_longitud(bounds1.getNorthEast().lng() - bounds1.getSouthWest().lng()  ) ;
	var incr2 = bounds1.getNorthEast().lat() - bounds1.getSouthWest().lat();
	var bounds = new google.maps.LatLngBounds(
	new google.maps.LatLng( bounds1.getSouthWest().lat() + 1.0/6.0 * incr2, fix_longitud(bounds1.getSouthWest().lng() + 1.0/6.0 * incr1)   ),			
	new google.maps.LatLng( bounds1.getNorthEast().lat() - 1.0/6.0 * incr2, fix_longitud(bounds1.getNorthEast().lng() - 1.0/6.0 * incr1)   )	
	);
	return bounds;
}
function center_rectangle(){

	incr_x=rectangle_get_xwidth();
	incr_y=rectangle_get_ywidth();
	l1   = sk_lat - incr_y / 2.0 ;
	long1= fix_longitud(sk_lon  - incr_x / 2.0) ;
	l2   = sk_lat + incr_y / 2.0 ;
	long2= fix_longitud(sk_lon  + incr_x / 2.0) ;


	var bounds = new google.maps.LatLngBounds(
		new google.maps.LatLng(l1,long1),
		new google.maps.LatLng(l2,long2)
	);

	return bounds;
}


function grab_down(){
	if (rectangle==undefined || rectangle==null){return;}
	rectangle.setMap();
	marker.setMap();
	map.setOptions({ zoomControl: false, scrollwheel: false, disableDoubleClickZoom: true});
	
	for (i=0;i < YellowRects.length;i++){ if(YellowRects[i]!=undefined){YellowRects[i].setMap();} 	}
	return;
}
function grab_up(){
	if (rectangle==undefined || rectangle==null){return;}
//map.gm_accessors_.bounds.Ic.projectionBounds.I J K L
//map.gm_accessors_.bounds.Ic.center
	if (rectangle.getDraggable()){ grab_ini();} else
	{grab_next();}
	return;	
}
function grab_ini(){
	
	
	var r=window.devicePixelRatio;
	var r_nw = get_northwest(rectangle.getBounds());
	var r_se = get_southeast(rectangle.getBounds());
	var sw_lat=rectangle.getBounds().getSouthWest().lat();
	var sw_lon=rectangle.getBounds().getSouthWest().lng();
	var ne_lat=rectangle.getBounds().getNorthEast().lat();
	var ne_lon=rectangle.getBounds().getNorthEast().lng();
	
	Co1 = lat_to_pix(r_nw, map.getZoom());Co1.x=Math.floor(Co1.x*r);Co1.y=Math.floor(Co1.y*r);
	Co2 = lat_to_pix(r_se, map.getZoom());Co2.x=Math.floor(Co2.x*r);Co2.y=Math.floor(Co2.y*r);
	Wpix= fix_longPIX(Co2.x - Co1.x, map.getZoom());
	Hpix= Co2.y - Co1.y;

 
	//##########################

	Ix=findDistance(sk_lat,sw_lon,sk_lat,sk_lon);if ((sw_lon-sk_lon) < 0){Ix=Ix*-1.0;};
	Iy=findDistance(sw_lat,sk_lon,sk_lat,sk_lon);if ((sw_lat-sk_lat) < 0){Iy=Iy*-1.0;};
	Winch=findDistance(sw_lat,sw_lon,sw_lat,ne_lon);
	Hinch=Winch*Hpix/Wpix;
	//Hinch=findDistance(sw_lat,sw_lon,ne_lat,sw_lon);alert(Hinch-findDistance(sw_lat,sw_lon,ne_lat,sw_lon));
	

document.getElementById('aup').style.visibility="visible";
document.getElementById('adown').style.visibility="visible";
document.getElementById('aleft').style.visibility="visible";
document.getElementById('aright').style.visibility="visible";
	
rectangle.setOptions({
		editable: false,
		draggable: false
		});
	
	
	grab_next();
	return;
}
function grab_next(){
var r=window.devicePixelRatio;
//########################
	var m_nw = get_northwest(map.getBounds());
	var co0 = lat_to_pix(m_nw, map.getZoom());
co0.x=Math.floor(co0.x*r);co0.y=Math.floor(co0.y*r);
	
	var co1_x = Co1.x + utilex*Wpix;
	var co1_y = Co1.y + utiley*Hpix;
	var co2_x = Co2.x + utilex*Wpix;
	var co2_y = Co2.y + utiley*Hpix;
	
	var x1=fix_longPIX(co1_x-co0.x, map.getZoom());
	var y1=co1_y-co0.y;
	
	
	var x2=fix_longPIX(co2_x-co0.x, map.getZoom());
	var y2=co2_y-co0.y;
//alert([co0.y/window.devicePixelRatio,co1_y/window.devicePixelRatio,co2_y/window.devicePixelRatio,map.getZoom()]);
	iix= Ix + utilex*Winch;
	iiy= Iy - utiley*Hinch;

	if (check_rectangle()){return;}

image_cont+=1;

var sw_lat=rectangle.getBounds().getSouthWest().lat();
var sw_lon=rectangle.getBounds().getSouthWest().lng();
var ne_lat=rectangle.getBounds().getNorthEast().lat();
var ne_lon=rectangle.getBounds().getNorthEast().lng();

str=JSON.stringify([x1,y1,x2,y2,iix,iiy,Winch,Hinch,utilex,utiley,image_cont,sw_lat,sw_lon,ne_lat,ne_lon]);


html2canvas( document.getElementById("map-canvas"),{allowTaint:true,useCORS: true,x:(x1/r),y:(y1/r),width:((x2-x1)/r), height:(y2-y1)/r}).then(canvas => {
	 
var blob = CanvasToBMP24.toBlob(canvas);
saveAs(blob, "grab_" + image_cont + ".bmp");

//  canvas.toBlob(blob => saveAs(blob, "grab_" + image_cont + ".png"));


});

sketchup.fgrab(str);
	for (i=0;i < YellowRects.length;i++){ if(YellowRects[i]!=undefined){YellowRects[i].setMap(map);} 	}
	marker.setMap(map);
	rectangle.setMap(map);	
	backrectangle(rectangle.getBounds());
	
return;
}

function ff_join(){

	sketchup.fjoin();
}

function draw_su_pos(){
	p11 = new google.maps.LatLng(sk_lat,sk_lon);
	marker = new google.maps.Marker({
		map: map,
		title: "SketchUp Origin "+ sk_lat.toString() + sk_lon.toString(),
		position: p11
	  });
	return;
}
function fix_longitud(res){
	if (res >  180.0){ res = res-360;}
	if (res < -180.0){ res = 360+res;}
	return res;
}
function fix_longPIX(res,zoom){
var r=window.devicePixelRatio;

	npix=Math.floor(TILE_SIZE*Math.pow(2,zoom)*r);
	if (res >  npix/2){ res = res-npix;}
	if (res < -npix/2){ res = npix+res;}
	return res;
}
function get_northwest(bounds){
	var northwest = new google.maps.LatLng(
		bounds.getNorthEast().lat(),
		bounds.getSouthWest().lng() 
	)
return northwest;
}
function get_southeast(bounds){
	var southeast = new google.maps.LatLng(
		bounds.getSouthWest().lat(), 
		bounds.getNorthEast().lng()
	)
return southeast;
}
function rectangle_get_xwidth(){
	var bounds1 =rectangle.getBounds();
	var incr1 = fix_longitud(bounds1.getNorthEast().lng() - bounds1.getSouthWest().lng()  ) ;
	return incr1;
}
function rectangle_get_ywidth(){
	var bounds1 =rectangle.getBounds();
	var incr2 = bounds1.getNorthEast().lat() - bounds1.getSouthWest().lat();
	return incr2;
}
function fup(){
if (rectangle.getDraggable()==true){ return;}
	utiley-=1;
	var bounds1 =rectangle.getBounds();
	var incr2 = bounds1.getNorthEast().lat() - bounds1.getSouthWest().lat();
	var newbounds = new google.maps.LatLngBounds(
	new google.maps.LatLng( bounds1.getSouthWest().lat() +incr2, bounds1.getSouthWest().lng() ),			
	new google.maps.LatLng( bounds1.getNorthEast().lat() +incr2, bounds1.getNorthEast().lng() )	
	);

	rectangle.setMap(); 
	rectangle.bounds=newbounds;
	rectangle.setMap(map);
	map.panBy(0,-Hpix/window.devicePixelRatio);
	return;
}
function fdown(){
if (rectangle.getDraggable()==true){ return;}
	utiley+=1;
	var bounds1 =rectangle.getBounds();
	var incr2 = bounds1.getNorthEast().lat() - bounds1.getSouthWest().lat();
	var newbounds = new google.maps.LatLngBounds(
	new google.maps.LatLng( bounds1.getSouthWest().lat() -incr2, bounds1.getSouthWest().lng() ),			
	new google.maps.LatLng( bounds1.getNorthEast().lat() -incr2, bounds1.getNorthEast().lng() )	
	);

	rectangle.setMap(); 
	rectangle.bounds=newbounds;
	rectangle.setMap(map);
	map.panBy( 0,Hpix/window.devicePixelRatio);
	return;
}
function fleft(){
if (rectangle.getDraggable()==true){ return;}
utilex-=1;
	var bounds1 =rectangle.getBounds();
	var incr1 = fix_longitud(bounds1.getNorthEast().lng() - bounds1.getSouthWest().lng()  ) ;
	var newbounds = new google.maps.LatLngBounds(
	new google.maps.LatLng( bounds1.getSouthWest().lat(), fix_longitud(bounds1.getSouthWest().lng()-incr1 )),			
	new google.maps.LatLng( bounds1.getNorthEast().lat(), fix_longitud(bounds1.getNorthEast().lng()-incr1 ))	
	);

	rectangle.setMap(); 
	rectangle.bounds=newbounds;
	rectangle.setMap(map);
	map.panBy(-Wpix/window.devicePixelRatio, 0);
	return;

}
function fright(){
if (rectangle.getDraggable()==true){ return;}
utilex+=1;
	var bounds1 =rectangle.getBounds();
	var incr1 = fix_longitud(bounds1.getNorthEast().lng() - bounds1.getSouthWest().lng()  ) ;
	var newbounds = new google.maps.LatLngBounds(
	new google.maps.LatLng( bounds1.getSouthWest().lat(), fix_longitud(bounds1.getSouthWest().lng()+incr1 )),			
	new google.maps.LatLng( bounds1.getNorthEast().lat(), fix_longitud(bounds1.getNorthEast().lng()+incr1 ))	
	);

	rectangle.setMap(); 
	rectangle.bounds=newbounds;
	rectangle.setMap(map);
	map.panBy(Wpix/window.devicePixelRatio, 0);
	return;
}
var YellowRects=[];
function backrectangle(bounds){
  var rec_ = new google.maps.Rectangle({
    bounds:bounds,
    editable: false,
	draggable: false,
	strokeOpacity: 0,
	fillColor: '#69af0f',
    fillOpacity: 0.35
  });
  rec_.setMap(map);
  YellowRects.push(rec_);
  
  return;

}



function check_rectangle(){

if (map.getZoom()<4){alert('You must use more zoom.');return_to_dragg();return true;}

	var ymap = map.getBounds().getNorthEast().lat()-map.getBounds().getSouthWest().lat();
	var yrec = rectangle.getBounds().getNorthEast().lat()-rectangle.getBounds().getSouthWest().lat();
	var xmap=fix_longitud(map.getBounds().getNorthEast().lng()-map.getBounds().getSouthWest().lng());
	var xrec=fix_longitud(rectangle.getBounds().getNorthEast().lng()-rectangle.getBounds().getSouthWest().lng());

if (xrec>180 ){
	alert('Rectangle to big for SU model.Max 180?.');
	return_to_dragg();
	return true;
	}

if ( (xmap-xrec <0) || (ymap-yrec)<0)
{	alert('Rectangle can not be bigger than viewport.'); 
	return_to_dragg();
	return true;
}


if (
! map.getBounds().contains(rectangle.getBounds().getNorthEast()) ||
! map.getBounds().contains(rectangle.getBounds().getSouthWest())
){
	alert('Rectangle must be inside viewport');
	for (i=0;i < YellowRects.length;i++){ if(YellowRects[i]!=undefined){YellowRects[i].setMap(map);} 	}
	marker.setMap(map);
	rectangle.setMap(map);
	map.panTo(rectangle.getBounds().getCenter());
	return true;
}

return false;
}
function return_to_dragg(){

 for (i=0;i < YellowRects.length;i++){ if(YellowRects[i]!=undefined){YellowRects[i].setMap(map);} 	}
	marker.setMap(map);
	map.setOptions({ zoomControl: true, scrollwheel: true, disableDoubleClickZoom: false});
	document.getElementById('aup').style.visibility="hidden";
	document.getElementById('adown').style.visibility="hidden";
	document.getElementById('aleft').style.visibility="hidden";
	document.getElementById('aright').style.visibility="hidden";
		
	rectangle.setMap();
	rectangle=undefined;
	selectregion();
	selectregion();//to center;
	return;
}























/*! canvas-to-bmp version 1.0 ALPHA
    (c) 2015 Ken "Epistemex" Fyrstenberg
    MIT License (this header required)
var blob = CanvasToBMP.toBlob(canvas);	
var dataURI = CanvasToBMP.toDataURL(canvas);
*/

var CanvasToBMP = {

  /**
   * Convert a canvas element to ArrayBuffer containing a BMP file
   * with support for 32-bit (alpha).
   *
   * Note that CORS requirement must be fulfilled.
   *
   * @param {HTMLCanvasElement} canvas - the canvas element to convert
   * @return {ArrayBuffer}
   */
  toArrayBuffer: function(canvas) {

    var w = canvas.width,
        h = canvas.height,
        w4 = w * 4,
        idata = canvas.getContext("2d").getImageData(0, 0, w, h),
        data32 = new Uint32Array(idata.data.buffer), // 32-bit representation of canvas

        stride = Math.floor((32 * w + 31) / 32) * 4, // row length incl. padding
        pixelArraySize = stride * h,                 // total bitmap size
        fileLength = 122 + pixelArraySize,           // header size is known + bitmap

        file = new ArrayBuffer(fileLength),          // raw byte buffer (returned)
        view = new DataView(file),                   // handle endian, reg. width etc.
        pos = 0, x, y = 0, p, s = 0, a, v;

    // write file header
    setU16(0x4d42);          // BM
    setU32(fileLength);      // total length
    pos += 4;                // skip unused fields
    setU32(0x7a);            // offset to pixels

    // DIB header
    setU32(108);             // header size 122-108=14 bytes file header
    setU32(w);
    setU32(-h >>> 0);        // negative = top-to-bottom
    setU16(1);               // 1 plane
    setU16(32);              // 32-bits (RGBA)
    setU32(3);               // no compression (BI_BITFIELDS, 3)
    setU32(pixelArraySize);  // bitmap size incl. padding (stride x height)
    setU32(2835);            // pixels/meter h (~72 DPI x 39.3701 inch/m)
    setU32(2835);            // pixels/meter v
    pos += 8;                // skip color/important colors
    setU32(0xff0000);        // red channel mask
    setU32(0xff00);          // green channel mask
    setU32(0xff);            // blue channel mask
    setU32(0xff000000);      // alpha channel mask
    setU32(0x57696e20);      // " win" color space

    // bitmap data, change order of ABGR to BGRA
    while (y < h) {
      p = 0x7a + y * stride; // offset + stride x height 122=0x7a
      x = 0;
      while (x < w4) {
        v = data32[s++];                     // get ABGR
        a = v >>> 24;                        // alpha channel
        view.setUint32(p + x, (v << 8) | a); // set BGRA
        x += 4;
      }
      y++
    }

    return file;

    // helper method to move current buffer position
    function setU16(data) {view.setUint16(pos, data, true); pos += 2}
    function setU32(data) {view.setUint32(pos, data, true); pos += 4}
  },

  /**
   * Converts a canvas to BMP file, returns a Blob representing the
   * file. This can be used with URL.createObjectURL().
   * Note that CORS requirement must be fulfilled.
   *
   * @param {HTMLCanvasElement} canvas - the canvas element to convert
   * @return {Blob}
   */
  toBlob: function(canvas) {
    return new Blob([this.toArrayBuffer(canvas)], {
      type: "image/bmp"
    });
  },

  /**
   * Converts the canvas to a data-URI representing a BMP file.
   * Note that CORS requirement must be fulfilled.
   *
   * @param canvas
   * @return {string}
   */
  toDataURL: function(canvas) {
    var buffer = new Uint8Array(this.toArrayBuffer(canvas)),
        bs = "", i = 0, l = buffer.length;
    while (i < l) bs += String.fromCharCode(buffer[i++]);
    return "data:image/bmp;base64," + btoa(bs);
  }
};


/*!
 canvas-to-bmp version 24 bits
*/

var CanvasToBMP24 = {

  
  toArrayBuffer: function(canvas) {

    var w = canvas.width,
        h = canvas.height,
        w4 = w * 4,
        idata = canvas.getContext("2d").getImageData(0, 0, w, h),
        data32 = new Uint32Array(idata.data.buffer), // 32-bit representation of canvas



//getImageDAta returns an ImageData object, ImageData.data returns a:
// Uint8ClampedArray representing a one-dimensional array containing the data in the RGBA order????,
// with integer values between 0 and 255 (inclusive).


        stride = Math.ceil((24 * w) / 32.0) * 4, 
  
        pixelArraySize = stride * h,                 // total bitmap size
        fileLength = 54 + pixelArraySize,           // header size is known + bitmap

        file = new ArrayBuffer(fileLength),          // raw byte buffer (returned)
        view = new DataView(file),                   // handle endian, reg. width etc.
        pos = 0, x,xx, y = 0, p, s = 0, a, v;

    // write file header
    setU16(0x4d42);          // BM
    setU32(fileLength);      // total length
    pos += 4;                // skip unused fields (4 bytes )
    setU32(0x36);            // offset to pixels 0x36=54decimal
 
    // DIB header
    setU32(40);              // header size
    setU32(w);               // width
    setU32(h);               // height 
    setU16(1);               // 1 plane
    setU16(24);              // bits per pixel 24 (RGB)
    setU32(0);               // no compression 
    setU32(pixelArraySize);  // bitmap size incl. padding (stride x height)
    setU32(2835);            // pixels/meter h (~72 DPI x 39.3701 inch/m)
    setU32(2835);            // pixels/meter v
    pos += 8;                // skip color/important colors
    

for (var i = h - 1; i >= 0; i--) {
   
      p = 0x36 + i * stride; // offset + stride x height
      x = 0;
	  xx=0;
      while (x < w4) {
        v = data32[s++];                     // get ABGR
        a = v >>> 24;                        // alpha channel
// set BGR 
view.setUint8(p + xx, ((v >> 16) & 0x000000FF));// 8 8 8 8
view.setUint8(p + xx+1, ((v >> 8) & 0x000000FF));
view.setUint8(p + xx+2, (v & 0x000000FF));
        x += 4;
		xx  +=3;
      }
      
    }

    return file;

    // helper method to move current buffer position
	function setU16(data) {view.setUint8(pos, data, true); pos += 1}
    function setU16(data) {view.setUint16(pos, data, true); pos += 2}
    function setU32(data) {view.setUint32(pos, data, true); pos += 4}
  },

  /**
   * Converts a canvas to BMP file, returns a Blob representing the
   * file. This can be used with URL.createObjectURL().
   * Note that CORS requirement must be fulfilled.
   *
   * @param {HTMLCanvasElement} canvas - the canvas element to convert
   * @return {Blob}
   */
  toBlob: function(canvas) {
    return new Blob([this.toArrayBuffer(canvas)], {
      type: "image/bmp"
    });
  },

  /**
   * Converts the canvas to a data-URI representing a BMP file.
   * Note that CORS requirement must be fulfilled.
   *
   * @param canvas
   * @return {string}
   */
  toDataURL: function(canvas) {
    var buffer = new Uint8Array(this.toArrayBuffer(canvas)),
        bs = "", i = 0, l = buffer.length;
    while (i < l) bs += String.fromCharCode(buffer[i++]);
    return "data:image/bmp;base64," + btoa(bs);
  }
};

 













 


  